/********************************************************************************
 * Created on Sep 6, 2005
 *
 * Copyright (c) 2005 University of Southampton
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy 
 * of this software and associated documentation files (the "Software"), to deal 
 * in the Software without restriction, including without limitation the rights 
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
 * copies of the Software, and to permit persons to whom the Software is 
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in 
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS 
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE 
 * SOFTWARE.
 *******************************************************************************/

package org.pasoa.common;

/**
 * Defines common constants used across PASOA project.
 * 
 * @author pgroth, sm
 *
 */
public interface Constants
{
    /**
     * A key to get a provenance store url from a map
     */
    public static final String PROVENANCE_STORE_URL = "provenance store URL";
    
    /**
     * PRecord namespace
     */
    public static final String PRECORD_NS   = "http://www.pasoa.org/schemas/version023/record/PRecord.xsd";
    
    /**
     * PQuery namespace
     */
    public static final String PQUERY_NS    = "http://www.pasoa.org/schemas/version023/pquery/ProvenanceQuery.xsd";
    
    /**
     * PStructure namespace
     */
    public static final String PSTRUCT_NS   = "http://www.pasoa.org/schemas/version023/PStruct.xsd";
    
    /**
     * Web Services PStructure namespace
     */
    public static final String WPSTRUCT_NS = "http://www.pasoa.org/schemas/version023/WPStruct.xsd";
    
    /**
     * PHeader namespace
     */
    public static final String PHEADER_NS   = "http://www.pasoa.org/schemas/version023/PHeader.xsd";
    
    
    /**
     * PASOA Xquery namespance
     */
    public static final String WSXQUERY_NS  = "http://www.pasoa.org/schemas/version023/xquery/WSXQuery.xsd";
    
    /**
     * PManage namespace
     */
    public static final String PMANAGE_NS   = "http://www.pasoa.org/schemas/version023/PManage.xsd";

    /**
     * The Client View's viewkind
     */
    public static final String CLIENT_VIEW  = "isSender";
    
    /**
     * The Service View's viewkind
     */
    public static final String SERVICE_VIEW = "isReceiver";
   
    public static final String WSXQUERY_PREFIX = "xq";
    
}
