/********************************************************************************
 * Created on Jul 6, 2005
 *
 * Copyright (c) 2005 University of Southampton
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy 
 * of this software and associated documentation files (the "Software"), to deal 
 * in the Software without restriction, including without limitation the rights 
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
 * copies of the Software, and to permit persons to whom the Software is 
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in 
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS 
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE 
 * SOFTWARE.
 *******************************************************************************/

package org.pasoa.common;

import org.pasoa.common.structure.GlobalPAssertionKey;
import org.w3c.dom.Element;

/**
 * Record interface
 * @author Paul Groth pg03r@ecs.soton.ac.uk
 */
public interface Record
{
    
    public static final String INTERACTION_PA      = "interactionPAssertion";
    public static final String ACTOR_STATE_PA      = "actorStatePAssertion";
    public static final String RELATIONSHIP_PA     = "relationshipPAssertion";
    public static final String SUBMISSION_FINISHED = "submissionFinished";
    
    public void record (GlobalPAssertionKey gpid, Element asserter, Element assertion, String kindOfAssertion) throws Exception;

}
