package org.pasoa.common.structure;

import org.w3c.dom.Element;

/**
 * This class models an ActorStatePAssertion 
 * 
 * @author pgroth, sm
 */
public class ActorStatePAssertion extends PAssertion {
    private Element state;
    
    /**
     * Construct an actor state PAssertion
     * 
     * @param localPAssertionID the id of the p-assertion
     * @param stateBody a DOM element that represents part of the actor's state
     */
    public ActorStatePAssertion (String localPAssertionID, Element stateBody) {
        super (localPAssertionID);
        state = stateBody;
    }
    
    /**
     * An actor state p-assertion contains some element that represents
     * part of an actor's state.
     * 
     * @return an Element that represents part of the actor's state
     */
    public Element getActorStateBody () {
        return state;
    }
}
