package org.pasoa.common.structure;

import java.util.List;

/**
 * Models an interaction context, which allows metadata to be associated
 * with a particular interaction.
 * 
 * @author pgroth
 */
public class InteractionContext 
{
    private InteractionKey _interactionKey;
    private List           _interactionMetadata;
    
    /**
     * Construct an InteractionContext.
     * 
     * @param interactionKey the interaction the metadata is about
     * @param interactionMetadata pieces of metadata
     */
    public InteractionContext (InteractionKey interactionKey, List interactionMetadata) {
        _interactionKey      = interactionKey;
        _interactionMetadata = interactionMetadata;
    }
    
    public InteractionKey getInteractionKey () {
        return _interactionKey;
    }
    
    public List getInteractionMetadata () {
        return _interactionMetadata;
    }
}
