package org.pasoa.common.structure;

import org.w3c.dom.Element;

/**
 * Models an assertion about an Interaction.
 * 
 * @author pgroth
 * 
 */
public class InteractionPAssertion extends PAssertion
{
    private Element body;
    private String transform;

    /**
     * Construct an interaction p-assertion.
     * 
     * @param localPAssertionID identify this assertion uniquely within a view
     * @param documentationStyle the documentation style of the message body.
     *            this should be a URL
     * @param messageBody the actual assertion content about the message
     *            exchanged in an interaction between two actors
     */
    public InteractionPAssertion(String localPAssertionID,
            String documentationStyle, Element messageBody)
    {
        super (localPAssertionID);
        transform = documentationStyle;
        body = messageBody;

    }

    public String getDocumentationStyle()
    {
        return transform;
    }

    public Element getMessageBody()
    {
        return body;
    }
}
