package org.pasoa.common.structure;

import java.io.Serializable;

/**
 * Represents a link to a provenance store. I.e. a pointer to
 * another provenance store.
 * @author pgroth
 *
 */
public class Link implements Serializable
{
    private String linked;
    
    /**
     * Construct a link
     * @param toStore the url to the store as a string
     */
    public Link (String toStore) {
        linked = toStore;
    }
    
    public boolean equals (Object other) {
        return (other instanceof Link) && ((Link) other).getStoreURL ().equals (linked);
    }
    
    /**
     * If method returns "" then the link
     * is blank
     * @return
     */
    public String getStoreURL () {
        return linked;
    }
    
    public int hashCode () {
        return linked.hashCode ();
    }
}
