package org.pasoa.common.structure;

import java.io.Serializable;

/**
 * Base class for all p-assertions
 * @author pgroth, sm
 *
 */
public class PAssertion implements Serializable
{
    private String  id;
    
    /**
     * Construct a p-assertion. Typically, one would not create a P-Assertion object
     * directly. Instead, one would use one of its sub classes. All p-assertions
     * must have a local p-assertion id
     * 
     * @param localPAssertionID
     */
    public PAssertion (String localPAssertionID) {
        id = localPAssertionID;
    }
    
    public String getLocalPAssertionID () {
        return id;
    }
}
