package org.pasoa.common.structure;

import java.io.Serializable;
import org.w3c.dom.Element;

public class PAssertionDataKey implements Serializable {
    private GlobalPAssertionKey _gpak;
    private Element             _dataAccessor;
    
    public PAssertionDataKey (GlobalPAssertionKey gpak, Element dataAccessor) {
        _gpak         = gpak;
        _dataAccessor = dataAccessor;
    }
    
    public boolean equals (Object otherPADK) {
        PAssertionDataKey other;
        
        if (otherPADK instanceof PAssertionDataKey) {
            other = ((PAssertionDataKey) otherPADK);
            return other.getGlobalPAssertionKey ().equals (getGlobalPAssertionKey ()) &&
                    other.getDataAccessor ().equals (getDataAccessor ());
        } else {
            return false;
        }
    }
    
    public Element getDataAccessor () {
        return _dataAccessor;
    }
    
    public GlobalPAssertionKey getGlobalPAssertionKey () {
        return _gpak;
    }
    
    public int hashCode () {
        return _gpak.hashCode () + _dataAccessor.hashCode ();
    }
}
