/********************************************************************************
 * Created on Sep 7, 2005
 *
 * Copyright (c) 2005 University of Southampton
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy 
 * of this software and associated documentation files (the "Software"), to deal 
 * in the Software without restriction, including without limitation the rights 
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
 * copies of the Software, and to permit persons to whom the Software is 
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in 
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS 
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE 
 * SOFTWARE.
 *******************************************************************************/

package org.pasoa.common.structure;

import org.w3c.dom.Element;

/**
 * Extends the Record class to support the recording of the submission finished message.
 * 
 * @author pgroth
 */
public class RecordSf extends Record
{
    private int _numOfExpectedPAssertions;
    
    /**
     * @see Record
     * 
     * Same as the Record class constructor except takes an int with the number
     * of expected p-assertions instead of a PAssertion
     */ 
    public RecordSf (int expectedPAssertions, InteractionKey irid, String viewKind, Element asserter) {
        super (new PAssertion ("blank"), irid, viewKind, asserter);
        _numOfExpectedPAssertions = expectedPAssertions;
    }
    
    public int getNumberOfExpectedPAssertions()
    {
        return _numOfExpectedPAssertions;
    }
}
