package org.pasoa.common.structure.serialiser;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import org.pasoa.common.Constants;
import org.pasoa.common.structure.InteractionContext;
import org.pasoa.common.structure.InteractionKey;
import org.pasoa.common.structure.PAssertionDataKey;
import org.pasoa.common.structure.PHeader;
import org.pasoa.dommap.SimpleDocument;
import org.pasoa.dommap.SimpleElement;
import org.pasoa.dommap.SimpleText;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * Provides convience methods for serialising org.pasoa.common.structure
 * objects to XML.
 * 
 * WARNING: This class is not finished. It needs to be though ;-)
 * @author sm
 *
 */
public class PStructureSerialiser {
    private Map _prefixToSpace;
    
    public static final String _pstructurePrefix = "ps";
    public static final String _pheaderPrefix    = "ph";
    
    public PStructureSerialiser () {
        _prefixToSpace = new HashMap ();
        _prefixToSpace.put (_pstructurePrefix, Constants.PSTRUCT_NS);
        _prefixToSpace.put (_pheaderPrefix,    Constants.PHEADER_NS);
    }
    
    public Document serialiseInteractionKey (InteractionKey irid) {
        SimpleDocument doc     = new SimpleDocument (_prefixToSpace);
        SimpleElement  root    = new SimpleElement  (doc, Constants.PSTRUCT_NS, "interactionKey");
        SimpleElement  source  = new SimpleElement  (doc, Constants.PSTRUCT_NS, "messageSource");
        SimpleElement  sink    = new SimpleElement  (doc, Constants.PSTRUCT_NS, "messageSink");
        SimpleElement  id      = new SimpleElement  (doc, Constants.PSTRUCT_NS, "interactionId");
        
        if (irid.getMessageSource () != null) {
            source.appendChild (irid.getMessageSource ());
        } else {
            source.appendChild (new SimpleText (doc, "null"));
        }
        root.appendChild (source);
        
        if (irid.getMessageSink () != null) {
            sink.appendChild (irid.getMessageSink ());
        } else {
            sink.appendChild (new SimpleText (doc, "null"));
        }
        root.   appendChild (sink);
        
        if (irid.getInteractionID () != null) {
            id.appendChild (new SimpleText (doc, irid.getInteractionID ()));
        } else {
            id.appendChild (new SimpleText (doc, "null"));
        }
        root.appendChild (id);
        doc. appendChild (root);
        
        return doc;
    }
    
    public Document serialiseInteractionContext (InteractionContext context) {
        SimpleDocument doc    = new SimpleDocument (_prefixToSpace);
        SimpleElement  root   = new SimpleElement  (doc, Constants.PHEADER_NS, "interactionContext");
        Iterator       eachMd = context.getInteractionMetadata ().iterator ();
        
        root.appendChild (serialiseInteractionKey (context.getInteractionKey ()).getDocumentElement ());
        while (eachMd.hasNext ()) {
            root.appendChild ((Element) eachMd.next ());
        }
        
        doc.appendChild (root);
        
        return doc;
    }
    
    public Document serialisePHeader (PHeader pheader) {
        SimpleDocument doc     = new SimpleDocument (_prefixToSpace);
        SimpleElement  root    = new SimpleElement  (doc, Constants.PHEADER_NS, "pheader");
        Iterator       eachMd  = pheader.getInteractionMetadata ().iterator ();
        Iterator       eachCtx = pheader.getInteractionContexts ().iterator ();
        
        root.appendChild (serialiseInteractionKey (pheader.getInteractionKey ()).getDocumentElement ());
        while (eachMd.hasNext ()) {
            root.appendChild ((Element) eachMd.next ());
        }
        while (eachCtx.hasNext ()) {
            root.appendChild (serialiseInteractionContext ((InteractionContext) eachMd.next ()).getDocumentElement ());
        }
        
        doc.appendChild (root);
        
        return doc;
    }
}
