package org.pasoa.dommap;

import java.util.AbstractList;
import java.util.Map;

class LazyList extends AbstractList {
    private String         name;
    private MappedDocument doc;
    private Map            context;
    private SimpleNode     _parent;
    
    public LazyList (MappedDocument document, SimpleNode parent, String parentName, Map parentContext) {
        name    = parentName;
        doc     = document;
        context = parentContext;
        _parent = parent;
    }
    
    public Object get (int index) {
        return doc.getChild (name, _parent, index, context);
    }
    
    public int size () {
        return doc.getNumberOfChildren (name, context);
    }
}
