package org.pasoa.dommap;

import org.w3c.dom.Attr;
import org.w3c.dom.DOMException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.TypeInfo;
import org.w3c.dom.UserDataHandler;

public class SimpleAttr extends SimpleNode implements Attr {
    private String value;
    
    public SimpleAttr (Document owner, String namespace, String localName, String attrValue) {
        super (owner, namespace, localName);
        value = attrValue;
    }
    
    public SimpleAttr (Document owner, Node parent, String namespace, String localName, String attrValue) {
        super (owner, namespace, localName);
        value = attrValue;
        //((Element) parent).setAttributeNodeNS (this);
    }
    
    public SimpleAttr (Document owner, Node parent, Attr convertFrom) {
        this (owner, parent, convertFrom.getNamespaceURI (), convertFrom.getLocalName (), convertFrom.getNodeValue ());
        if (convertFrom.getNamespaceURI () == null && convertFrom.getLocalName () == null) {
            setLocalName (convertFrom.getNodeName ());
        }
        /*if (getPrefix () == null && !getNodeName ().startsWith ("xmlns:") && owner instanceof SimpleDocument && owner != null) {
            addNamespace (((SimpleDocument) owner).newNamespace (), convertFrom.getNamespaceURI ());
        }*/
    }
    
    public SimpleNode cloneNode (boolean deep, Document newDocument) {
        return new SimpleAttr (newDocument, getNamespaceURI (), getLocalName (), value);
    }
    
    public String getName () {
        return getNodeName ();
    }
    
    public short getNodeType () {
        return Node.ATTRIBUTE_NODE;
    }
    
    public String getNodeValue () throws DOMException {
        return value;
    }
    
    public boolean getSpecified () {
        return true;
    }
    
    public String getValue () {
        return getNodeValue ();
    }
    
    public void setValue (String newValue) throws DOMException {
        value = newValue;
    }
    
    /* Non-implemented methods */
    
    public Object setUserData (String key, Object data, UserDataHandler handler) {
        throw new UnsupportedOperationException (); }
    
    public Object getUserData (String key) {
        throw new UnsupportedOperationException (); }
    
    public boolean isDefaultNamespace (String namespaceURI) {
        throw new UnsupportedOperationException (); }
    
    public String lookupNamespaceURI (String prefix) {
        throw new UnsupportedOperationException (); }
    
    public String lookupPrefix (String namespaceURI) {
        throw new UnsupportedOperationException (); }
    
    public void setNodeValue (String nodeValue) throws DOMException {
        throw new UnsupportedOperationException (); }
    
    public void setPrefix (String prefix) throws DOMException {
        throw new UnsupportedOperationException (); }
    
    public void setTextContent (String textContent) throws DOMException {
        throw new UnsupportedOperationException (); }
    
    public Node appendChild (Node newChild) throws DOMException {
        throw new UnsupportedOperationException (); }
    
    public short compareDocumentPosition (Node other) throws DOMException {
        throw new UnsupportedOperationException (); }
    
    public boolean isEqualNode (Node arg) {
        throw new UnsupportedOperationException (); }
    
    public boolean isSameNode (Node other) {
        throw new UnsupportedOperationException (); }
    
    public Node removeChild (Node oldChild) throws DOMException {
        throw new UnsupportedOperationException (); }
    
    public TypeInfo getSchemaTypeInfo () {
        throw new UnsupportedOperationException (); }
    
    public Node getPreviousSibling () {
        throw new UnsupportedOperationException (); }
    
    public Element getOwnerElement () {
        throw new UnsupportedOperationException (); }
    
    public NamedNodeMap getAttributes () {
        throw new UnsupportedOperationException (); }
    
    public String getBaseURI () {
        throw new UnsupportedOperationException (); }
    
    public NodeList getChildNodes () {
        throw new UnsupportedOperationException (); }
    
    public Object getFeature (String feature, String version) {
        throw new UnsupportedOperationException (); }
    
    public Node getLastChild () {
        throw new UnsupportedOperationException (); }
    
    public String getTextContent () throws DOMException {
        throw new UnsupportedOperationException (); }
    
    public boolean hasAttributes () {
        throw new UnsupportedOperationException (); }
    
    public boolean hasChildNodes () {
        throw new UnsupportedOperationException (); }
    
    public Node insertBefore (Node newChild, Node refChild) throws DOMException {
        throw new UnsupportedOperationException (); }
    
    public boolean isId () {
        throw new UnsupportedOperationException (); }
    
    public boolean isSupported (String feature, String version) {
        throw new UnsupportedOperationException (); }
    
    public void normalize () {
        throw new UnsupportedOperationException (); }
    
    public Node replaceChild (Node newChild, Node oldChild) throws DOMException {
        throw new UnsupportedOperationException (); }
}
