package org.pasoa.dommap;

import java.util.Iterator;
import java.util.List;
import org.w3c.dom.Attr;
import org.w3c.dom.DOMException;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;

public class SimpleNamedNodeMap implements NamedNodeMap {
    private List children;
    
    public SimpleNamedNodeMap (List childNodes) {
        children = childNodes;
    }
    
    public int getLength () {
        return children.size ();
        /*int  count = -1;
        Node attr;
         
        do {
            count += 1;
            attr = item (count);
        } while (attr != null);
         
        return count;*/
    }
    
    public Node getNamedItem (String name) {
        Iterator eachChild = children.iterator ();
        Attr     next      = null;
        
        while (eachChild.hasNext ()) {
            next = (Attr) eachChild.next ();
            if (next.getNodeName ().equals (name)) {
                return next;
            }
        }
        
        return null;
    }
    
    public Node getNamedItemNS (String namespaceURI, String localName) throws DOMException {
        Iterator eachChild = children.iterator ();
        Attr     next      = null;
        
        while (eachChild.hasNext ()) {
            next = (Attr) eachChild.next ();
            if (((next.getNamespaceURI () == null && namespaceURI == null) ||
                    (next.getNamespaceURI () != null && namespaceURI != null && next.getNamespaceURI ().equals (namespaceURI))) &&
                    ((next.getLocalName () == null && localName == null) ||
                    (next.getLocalName () != null && localName != null && next.getLocalName ().equals (localName)))) {
                return next;
            }
        }
        
        return null;
    }
    
    public Node item (int index) {
        return (Node) children.get (index);
        /*
        Iterator eachChild = children.iterator ();
        Node     next      = null;
         
        while (index >= 0 && eachChild.hasNext ()) {
            next = (Node) eachChild.next ();
            if (next.getNodeType () == Node.ATTRIBUTE_NODE) {
                index -= 1;
            }
        }
        if (index >= 0) {
            return null;
        } else {
            return next;
        }*/
    }
    
    public Iterator iterator () {
        return children.iterator ();
    }
    
    /* Non-implemented methods */
    
    public Node removeNamedItem (String name) throws DOMException {
        throw new UnsupportedOperationException ();
    }
    
    public Node setNamedItemNS (Node arg) throws DOMException {
        throw new UnsupportedOperationException ();
    }
    
    public Node setNamedItem (Node arg) throws DOMException {
        throw new UnsupportedOperationException ();
    }
    
    public Node removeNamedItemNS (String namespaceURI, String localName) throws DOMException {
        throw new UnsupportedOperationException ();
    }
}
