package org.pasoa.factory;

import java.util.Enumeration;
import java.util.Hashtable;


public class ProvenanceStoreRegistry
{
    private Hashtable provenanceStores;
    
    public ProvenanceStoreRegistry()
    {
        provenanceStores = new Hashtable();
    }
    
    public void registerPlugIn (String name, ProvenanceStore pStore) throws Exception {
        provenanceStores.put (name, pStore);
    }
    
    public void deregisterPlugIn (String name) throws Exception {
        provenanceStores.remove (name);   
    }
    
    public void shutdownAll() throws Exception
    {
        Enumeration keys = provenanceStores.keys();  
        while (keys.hasMoreElements()) {
            ProvenanceStore pStore = (ProvenanceStore)provenanceStores.get(keys.nextElement());
            pStore.shutdown();
        }
    }
    
    public ProvenanceStore lookup (String name) throws Exception {
        return (ProvenanceStore) provenanceStores.get (name);    
    }
    
    public Enumeration storeNames()
    {
        Enumeration keys = provenanceStores.keys();  
        return keys;
    }
}
