package org.pasoa.query.dom;

import java.util.HashMap;
import java.util.Map;
import org.pasoa.dommap.SimpleNode;
import org.pasoa.dommap.UnderlyingModelException;
import org.pasoa.common.Retrieval;
import org.w3c.dom.Node;

public class QStructureDocument extends QStructureActivityDocument {
    public QStructureDocument (Retrieval store, Map namespaces) throws Exception {
        super (store, namespaceMap (namespaces));
    }
        
    protected Node getChild (String name, SimpleNode parent, int index, Map context) throws UnderlyingModelException {
        Map  newContext = new HashMap (context);

        try {
            if (name.equals ("pasoa:pstruct")) {
                newContext.put ("exchange", getBasic ().getInteractionRecord (index));
                return buildElement (parent, index, "pasoa:interactionRecord", newContext);
            } else {
                return super.getChild (name, parent, index, context);
            }
        } catch (Exception problem) {
            throw new UnderlyingModelException (problem);
        }
    }
    
    protected int getNumberOfChildren (String name, Map context) {
        try {
            if (name.equals ("pasoa:pstruct")) {
                return (int) getBasic ().getNumberOfInteractionRecords ();
            } else {
                return super.getNumberOfChildren (name, context);
            }
        } catch (Exception problem) {
            throw new UnderlyingModelException (problem);
        }
    }
    
    protected String getRootElement () {
        return "pasoa:pstruct";
    }
}
