package org.pasoa.query.provenance;

import java.util.Collection;
import java.util.Map;
import org.pasoa.dommap.DOMWriter;
import org.pasoa.query.QueryProblem;
import org.pasoa.query.xpath.jaxen.XPathUtilities;
import org.w3c.dom.Node;

public class DocumentSetAccessorSearch {
    private String              _reference;
    private Map                 _namespaces;
    private String              _xmlMapping;
    private PStructureReference _searchOver;
    
    public DocumentSetAccessorSearch (String reference, Map namespaces, String xmlMapping, PStructureReference searchOver) {
        _reference  = reference;
        _namespaces = namespaces;
        _xmlMapping = xmlMapping;
        _searchOver = searchOver;
    }
    
    /**
     * @return A set of DOM Nodes
     */
    public Collection resolve () throws QueryProblem {
        // Deal with xml mapping
        Collection results = XPathUtilities.resolveNodeSet (_searchOver.getPStructure ().getDocumentElement (), _reference, _namespaces);

        return results;
    }
}
