package org.pasoa.query.provenance;

import java.util.HashMap;
import java.util.Map;
import org.pasoa.common.Constants;
import org.pasoa.common.PlugIn;
import org.pasoa.dommap.DOMWriter;
import org.pasoa.query.dom.QStructureDocument;
import org.pasoa.storage.StorageSystem;
import org.w3c.dom.Document;

public class ProvenanceQueryPlugin implements PlugIn {
    private Map _configuration;
    
    public Map getConfiguration () {
        return _configuration;
    }
    
    public String getDefaultResponse () {
        // Must be done synchrounously, so no default response
        return null;
    }
    
    public void initialize (Map configuration) {
        _configuration = configuration;
    }

    public Document process (Document document, StorageSystem ss) throws Exception {
        ProvenanceQueryDeserialiser parser       = new ProvenanceQueryDeserialiser ();
        ProvenanceQuerySerialiser   writer       = new ProvenanceQuerySerialiser ();
        //String                      thisStoreURL = (String) _configuration.get (Constants.PROVENANCE_STORE_URL);
        String                      thisStoreURL = "http://localhost:8080/preserv";
        QStructureDocument          data         = new QStructureDocument (ss.getRetrievalInterface (), new HashMap ());
        ProvenanceQuery             querier      = parser.deserialiseProvenanceQuery (document.getDocumentElement (), ss.getRetrievalInterface (), thisStoreURL, data);
        ProvenanceQueryResults      results      = querier.resolve ();
        
        return writer.serialiseProvenanceQueryResults (results);
    }
    
    public boolean receiveDispatchesSyncronously () {
        return true;
    }
}
