package org.pasoa.query.provenance;

import org.pasoa.common.structure.GlobalPAssertionKey;
import org.pasoa.common.structure.Link;
import org.pasoa.common.structure.ObjectID;
import org.w3c.dom.Element;

public class RelationshipTarget extends ObjectID {
    private String  _relation;
    private Element _assertion;
    
    public RelationshipTarget (GlobalPAssertionKey gpak, Element dataAccessor, String relation, String parameterName, Link objectLink, Element assertion) {
        super (gpak, parameterName, dataAccessor, objectLink);
        _relation  = relation;
        _assertion = assertion;
    }
    
    public RelationshipTarget (ObjectID object, String relation, Element assertion) {
        this (object.getGlobalPAssertionKey (), object.getDataAccessor (), relation, object.getParameterName (), object.getLink (), assertion);
    }

    public Element getAssertion () {
        return _assertion;
    }
    
    public String getRelation () {
        return _relation;
    }
}
