package org.pasoa.query.xpath;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import org.pasoa.common.Constants;
import org.pasoa.dommap.DOMDeserialiser;
import org.w3c.dom.Element;

public class XPathQueryDeserialiser {
    public XPathQueryDeserialiser () {
    }
    
    public XPathQueryRequest deserialiseXPathQueryRequest (Element serialised) {
        if (serialised == null) {
            return null;
        }
        DOMDeserialiser parse      = new DOMDeserialiser (Constants.WSXQUERY_NS);
        String          path       = parse.text (serialised, "path");
        Map             namespaces = deserialiseNamespaceMappings (serialised);
        
        return new XPathQueryRequest (path, namespaces);
    }

    public Map deserialiseNamespaceMappings (Element serialised) {
        if (serialised == null) {
            return null;
        }
        
        Map             mappings = new HashMap ();
        DOMDeserialiser parse    = new DOMDeserialiser (Constants.WSXQUERY_NS);
        Iterator        eachMap  = parse.iterator (serialised, "namespaceMapping");
        
        while (eachMap.hasNext ()) {
            deserialiseNamespaceMapping ((Element) eachMap.next (), mappings);
        }
        
        return mappings;
    }
    
    public void deserialiseNamespaceMapping (Element serialised, Map addTo) {
        if (serialised == null) {
            return;
        }
        
        DOMDeserialiser parse     = new DOMDeserialiser (Constants.WSXQUERY_NS);
        String          prefix    = parse.text (serialised, "prefix");
        String          namespace = parse.text (serialised, "namespace");
        
        addTo.put (prefix, namespace);
    }
}
