package org.pasoa.query.xpath;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import org.pasoa.common.Constants;
import org.pasoa.common.Retrieval;
import org.pasoa.dommap.SimpleDocument;
import org.pasoa.dommap.SimpleElement;
import org.pasoa.query.QueryProblem;
import org.pasoa.query.dom.QStructureDocument;
import org.pasoa.query.xpath.jaxen.XPathUtilities;
import org.w3c.dom.Document;
import org.w3c.dom.Node;

public class XPathQueryImpl implements XPathQuery {
    public XPathQueryImpl () {
    }
    
    public Document resolve (Retrieval backend, String xpath, Map namespaces) throws QueryProblem {
        try {
            Iterator       eachResult = XPathUtilities.resolveNodeSet (new QStructureDocument (backend, namespaces).getDocumentElement (), xpath, namespaces).iterator ();
            SimpleDocument results    = new SimpleDocument (new HashMap ());
            SimpleElement  root       = new SimpleElement (results, Constants.WSXQUERY_NS, "results");
            Node           result;

            results.appendChild (root);
            while (eachResult.hasNext ()) {
                result = (Node) eachResult.next ();
                if (result instanceof Document) {
                    result = ((Document) result).getDocumentElement ();
                }
                root.appendChild (result);
            }

            return results;
        } catch (Exception problem) {
            throw new QueryProblem (problem);
        }
    }
}
