package org.pasoa.query.xpath;

import java.util.HashMap;
import java.util.Map;

public class XPathQueryRequest {
    private String _path;
    private Map    _namespaces;
    
    public XPathQueryRequest (String path, Map namespaces) {
        _path       = path;
        _namespaces = namespaces;
    }
    
    public XPathQueryRequest (String path) {
        this (path, new HashMap ());
    }
    
    public XPathQueryRequest addNamespace (String prefix, String namespace) {
        _namespaces.put (prefix, namespace);
        return this;
    }
    
    public Map getNamespaces () {
        return _namespaces;
    }
    
    public String getPath () {
        return _path;
    }
}
