package org.pasoa.query.xquery;

import java.util.HashMap;
import java.util.Map;
import org.pasoa.common.Constants;
import org.pasoa.common.PlugIn;
import org.pasoa.query.QueryConstants;
import org.pasoa.query.QueryProblem;
import org.pasoa.query.xpath.jaxen.XPathUtilities;
import org.pasoa.storage.StorageSystem;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

public class XQueryPlugIn implements PlugIn {
    public Document process (Document document, StorageSystem ss) throws Exception {
        HashMap spaceMap = new HashMap ();
        String  xquery;
        
        System.out.println ("XQueryPlugIn: processing");
        try {
            NodeList nl = document.getDocumentElement ().getChildNodes ();
            Element soapBody = null;
            for (int i = 0; i < nl.getLength (); i++) {
                if (nl.item (i) instanceof Element) {
                    if (((Element) nl.item (i)).getTagName ().endsWith ("Body")) {
                        soapBody = (Element) nl.item (i);
                        break;
                    }
                }
            }
            
            System.out.println ("Starting xquery processing");
            spaceMap.put (Constants.WSXQUERY_PREFIX, Constants.WSXQUERY_NS);
            spaceMap.put ("ps", Constants.PSTRUCT_NS);
            xquery = XPathUtilities.resolveString (soapBody, "string(//xq:xquery)", spaceMap);
            System.out.println ("xquery: " + xquery);
            
            xquery = xquery.replaceAll ("&lt;", "<");
            xquery = xquery.replaceAll ("&gt;", ">");
            
            System.out.println ("Going to resolve the xquery");
            
            return ss.resolve (xquery);
        } catch (QueryProblem problem) {
            problem.printStackTrace ();
            return QueryConstants.errorMsg (problem.getMessage ());
        } catch (Exception fault) {
            fault.printStackTrace ();
            return QueryConstants.errorMsg ("An error occur in processing your XQuery query");
        }
    }
    
    public boolean receiveDispatchesSyncronously () {
        return true;
    }
    
    public String getDefaultResponse () {
        // Must be done synchrounously, so no default response
        return null;
    }

    public Map getConfiguration()
    {
        // TODO Auto-generated method stub
        return null;
    }

    public void initialize(Map configuration)
    {
        // TODO Auto-generated method stub
        
    }
}
