package org.pasoa.storage.je;

import org.pasoa.common.structure.InteractionRecord;

import com.sleepycat.bind.EntryBinding;
import com.sleepycat.je.DatabaseEntry;
import com.sleepycat.je.DatabaseException;
import com.sleepycat.je.SecondaryDatabase;
import com.sleepycat.je.SecondaryKeyCreator;

public class IRSecondaryKeyCreator implements SecondaryKeyCreator
{
    private EntryBinding _irBinding;
    private EntryBinding _irIDBinding;
    
    public IRSecondaryKeyCreator (EntryBinding irBinding, EntryBinding irIDBinding)
    {
        _irBinding   = irBinding;  
        _irIDBinding = irIDBinding;
    }
    public boolean createSecondaryKey(SecondaryDatabase secondary,
                                      DatabaseEntry key,
                                      DatabaseEntry data,
                                      DatabaseEntry result)
        throws DatabaseException 
   {
        InteractionRecord ir = (InteractionRecord) _irBinding.entryToObject(data);
        if (ir.getInteractionKey() == null) {
            System.out.println("interaction id is null");
        }
        _irIDBinding.objectToEntry(ir.getInteractionKey().toString(), result);

        return true;
    }
}
