package org.pasoa.ui.xqforward;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.URL;
import java.net.URLDecoder;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.pasoa.dommap.DOMWriter;
import org.pasoa.util.ClientLib;

abstract class QueryForwarder extends HttpServlet {
    private ClientLib client;
    private String    context;
    
    public QueryForwarder (String port) {
        client  = new ClientLib ();
        context = port;
    }
    
    protected void doPost (HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        BufferedReader read = new BufferedReader (new InputStreamReader (request.getInputStream ()));
        String         line = URLDecoder.decode (read.readLine ());
        String         location;
        String         query;
        String         result;
        
        location = line.substring (0, line.indexOf ("&"));
        location = location.substring (location.indexOf ("=") + 1);
        query    = line.substring (line.indexOf ("&") + 1);
        query    = query.substring (query.indexOf ("=") + 1).trim ();
        
        result = doQuery (location, query);
        
        response.setStatus (HttpServletResponse.SC_OK);
        if (result.trim ().startsWith ("<html") || result.trim ().startsWith ("<HTML")) {
            response.setContentType ("text/html; charset=utf-8");
        } else {
            response.setContentType ("text/xml; charset=utf-8");
        }
        PrintWriter pw = response.getWriter ();
        
        pw.print (result);
        pw.close ();
    }
    
    
    protected String doQuery (String location, String query) throws IOException {
        location = location.trim () + "/" + context;
        
        try {
            return DOMWriter.writeToString (client.query (query, new URL (location)));
        } catch (Exception clientLibsRandomException) {
            throw new IOException (clientLibsRandomException.toString ());
        }
    }
    
    public void init () throws ServletException {
    }
}
