package org.pasoa.util.httpsoap;

import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.StringWriter;
import java.io.UnsupportedEncodingException;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLConnection;

//import javax.net.ssl.HostnameVerifier;
//import javax.net.ssl.HttpsURLConnection;
//import javax.net.ssl.SSLSession;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;


import org.pasoa.dommap.DOMWriter;
import org.pasoa.processor.Dispatcher;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.xml.sax.SAXException;

import sun.misc.BASE64Encoder;

public class DefaultDocumentClient implements HTTPDocumentClient {
    private DocumentBuilder builder;
    
    public DefaultDocumentClient () {
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance ();
        
        try {
            factory.setNamespaceAware (true);
            builder = factory.newDocumentBuilder ();
        } catch (ParserConfigurationException unexpected) {
            throw new RuntimeException (unexpected);
        }
    }
    
    public Document invoke (URL endpoint, Document request) throws IOException, SAXException {
        StringWriter strings = new StringWriter ();
        DOMWriter    writer  = new DOMWriter    (strings);
        InputStream  response;
        
        writer.write (request);
        response = post (endpoint, strings.getBuffer ().toString ());
        
        return builder.parse (response);
    }
    
    public Document invoke (URL endpoint, String request) throws IOException, SAXException {
        InputStream response;
        
        response = post (endpoint, request);
/*int read;
while ((read = response.read ()) > -1) {
    System.out.print ((char) read);
}
return null;*/
        return builder.parse (response);
    }
    
    /**
     * @throws UnsupportedEncodingException If the request string cannot be parsed into UTF-8
     */
    public Document invoke (Dispatcher dispatcher, String context, Node request) throws UnsupportedEncodingException, Exception {
        String                requestString = DOMWriter.writeToString (request);
        byte[]                requestBytes  = requestString.getBytes ("UTF-8");
        ByteArrayInputStream  input         = new ByteArrayInputStream (requestBytes);
        ByteArrayOutputStream output        = new ByteArrayOutputStream ();
        
        dispatcher.processAndDispatch (input, output, context);
        input.close ();
        output.close ();
        
        return builder.parse (new ByteArrayInputStream (output.toByteArray ()));
    }
    
    public InputStream post (URL url, String content) throws IOException {
        URLConnection    urlConn;;
        DataOutputStream printout;
        
        // Set up connection
        urlConn = url.openConnection ();
        urlConn.setDoInput (true);
        urlConn.setDoOutput (true);
        urlConn.setUseCaches (false);
        urlConn.setRequestProperty ("Content-Type", "text/xml");
        urlConn.setRequestProperty ("SoapAction", "");
        
       /* if (urlConn instanceof HttpsURLConnection) {
            System.out.println ("The connection is secure");
            String authorization = new BASE64Encoder().encode("username:password".getBytes()) ;
            urlConn.setRequestProperty("Authorization", "Basic " + authorization);
        }*/
        
        printout = new DataOutputStream (urlConn.getOutputStream ());
        printout.writeBytes (content);
        printout.flush ();
        printout.close ();
        
        try {
            return urlConn.getInputStream ();
        } catch (Exception e) {
            return ((HttpURLConnection)urlConn).getErrorStream ();
        }
    }
    
    public static String readString (InputStream textStream) throws IOException {
        StringBuffer   response = new StringBuffer ();
        BufferedReader input;
        String         str;
        
        input = new BufferedReader (new InputStreamReader (textStream));
        
        while (null != ((str = input.readLine ()))) {
            response.append (str);
            response.append ("\n");
        }
        input.close ();
        
        return response.toString ();
    }
}
