package org.pasoa.util.httpsoap;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import org.pasoa.common.Constants;
import org.pasoa.dommap.DOMSerialiser;
import org.pasoa.dommap.DOMWriter;

public class ProvenanceQueryRequestDocument extends SOAPDocument {
    private static String pStructPrefix = "ps";
    private static String pQueryPrefix  = "pq";
    
    public ProvenanceQueryRequestDocument (String queryDataHandleXPath, String scopingXPath, Map namespaces) {
        super (provenanceQueryNamespaces ());
        
        DOMSerialiser builder    = new DOMSerialiser (body);
        Iterator      eachPrefix = namespaces.keySet ().iterator ();
        Map           spaces     = new HashMap (namespaces);
        String        prefix;
        
        spaces.put (pStructPrefix, Constants.PSTRUCT_NS);
        builder.namespace (Constants.PQUERY_NS);
        builder.start     ("provenanceQuery");
        builder.start     ("queryDataHandle");
        builder.start     ("search");
        builder.start     ("xpathSearch");
        builder.single    ("path", queryDataHandleXPath);
        while (eachPrefix.hasNext ()) {
            prefix = (String) eachPrefix.next ();
            builder.start  ("namespaceMapping");
            builder.single ("prefix",    prefix);
            builder.single ("namespace", (String) namespaces.get (prefix));
            builder.end    ();
        }
        builder.end ();
        builder.end ();
        builder.start  ("pStructureReference");
        builder.single ("storeContents");
        builder.end    ();
        builder.start  ("relationshipTargetFilter");
        builder.start  ("check");
        builder.start  ("xpathSearch");
        builder.single ("path", scopingXPath);
        eachPrefix = namespaces.keySet ().iterator ();
        while (eachPrefix.hasNext ()) {
            prefix = (String) eachPrefix.next ();
            builder.start  ("namespaceMapping");
            builder.single ("prefix",    prefix);
            builder.single ("namespace", (String) namespaces.get (prefix));
            builder.end    ();
        }
    }
    
    private static Map provenanceQueryNamespaces () {
        Map spaces = new HashMap ();
        spaces.put (pQueryPrefix,  Constants.PQUERY_NS);
        spaces.put (pStructPrefix, Constants.PSTRUCT_NS);
        return spaces;
    }
}
