package org.pasoa.util.httpsoap;

import java.util.HashMap;
import java.util.Map;
import org.pasoa.dommap.SimpleDocument;
import org.pasoa.dommap.SimpleElement;

public class SOAPDocument extends SimpleDocument {
    public SimpleElement envelope;
    public SimpleElement header;
    public SimpleElement body;
    
    public static final String soapEnvURI = "http://schemas.xmlsoap.org/soap/envelope/";
    
    public SOAPDocument (Map spaces) {
        super (soapSpaces (spaces));
        
        envelope = new SimpleElement  (this, soapEnvURI, "Envelope");
        header   = new SimpleElement  (this, soapEnvURI, "Header");
        body     = new SimpleElement  (this, soapEnvURI, "Body");
        
        appendChild (envelope);
        envelope.appendChild (header);
        envelope.appendChild (body);
    }
    
    private static Map soapSpaces (Map spaces) {
        Map soapSpaces = new HashMap (spaces);
        soapSpaces.put ("soapenv", soapEnvURI);
        return soapSpaces;
    }
}
