package org.pasoa.util.httpsoap;

import java.util.HashMap;
import java.util.Map;
import org.pasoa.dommap.SimpleDocument;
import org.pasoa.dommap.SimpleElement;
import org.pasoa.dommap.SimpleText;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * A simple class for taking making a URL into a WS-addressing endpoint
 * xml representation
 * @author sm
 *
 */
public class WSAddressEndpoint {
    private String _url;
    
    public static final String wsaNamespace = "http://www.w3.org/2005/08/addressing";
    
    public WSAddressEndpoint (String url) {
        _url = url;
    }
    
    public Element getElement () {
        return getDocument ().getDocumentElement ();
    }
    
    public Document getDocument () {
        SimpleDocument doc = new SimpleDocument (wsMap ());
        SimpleElement  epr = new SimpleElement  (doc, wsaNamespace, "EndpointReference");
        SimpleElement  add = new SimpleElement  (doc, wsaNamespace, "Address");
        
        doc.appendChild (epr);
        epr.appendChild (add);
        add.appendChild (new SimpleText (doc, _url));
        
        return doc;
    }
    
    private static Map wsMap () {
        Map wsmap = new HashMap ();
        
        wsmap.put ("wsa", wsaNamespace);
        
        return wsmap;
    }
}
