package org.pasoa.util.httpsoap;

import java.util.Iterator;
import java.util.Map;

public class XPathRequestDocument extends XQueryRequestDocument {
    public XPathRequestDocument (String xpath, String root, String item, Map namespaces) {
        super (constructQuery (xpath, root, item, namespaces));
    }
    
    private static String constructQuery (String xpath, String root, String item, Map namespaces) {
        String xquery = "&lt;" + root + "&gt;" +
                " {for $n in $ps:pstruct" + xpath + " return" +
                " &lt;" + item + "&gt; {$n}" +
                " &lt;/" + item + "&gt;} " +
                " &lt;/" + root + "&gt;";
        Iterator eachPrefix = namespaces.keySet ().iterator ();
        String   prefix;
        String   namespace;
        
        while (eachPrefix.hasNext ()) {
            prefix    = (String) eachPrefix.next ();
            namespace = (String) namespaces.get (prefix);
            if (!prefix.equals ("ps")) {
                xquery = "declare namespace " + prefix + " = \"" + namespace + "\"; " + xquery;
            }
        }
        
        return xquery;
    }
}
